from __future__ import print_function
import sys, traceback, msvcrt, time, tempfile, os
import xml.etree.ElementTree
import Ice

Ice.loadSlice("--all -I. AnalyzerRemoteControl.ice")

import Ellisys.Platform.NetworkRemoteControl.Analyzer

# TODO: Please adapt the following constants to your needs
hostIp = "localhost"
hostPort = 12345

proxyString = "{0}:tcp -h {1} -p {2}".format(Ellisys.Platform.NetworkRemoteControl.Analyzer.AnalyzerRemoteControlIdentity, hostIp, hostPort)


class Tools(object):
	@staticmethod
	def ExportToCsv(remoteControl, outputFilename):
		f = open(outputFilename, 'w')
	
		rootHandle = remoteControl.OverviewRootItem()
		rootChildCount = remoteControl.GetOverviewItemChildCount(rootHandle)
		
		first = True
		
		for i in range(0, rootChildCount):
			childHandle = remoteControl.GetOverviewItemChild(rootHandle, i)
			childXmlReport = remoteControl.GetOverviewItemXmlReportFiltered(childHandle, [ "Overview Columns" ])
			childXml = xml.etree.ElementTree.fromstring(childXmlReport)
			
			if first:
				for column in childXml[0]:
					print("\"{0}\",".format(column.attrib.get('name', '').encode('utf-8')), end="", file=f) 

				print(file=f) 
					
				first = False
				
			for column in childXml[0]:
				print("\"{0}\",".format(column.attrib.get('value', '').encode('utf-8')), end="", file=f) 

			print(file=f) 
			
		f.close()


try:
	#
	# Initialize ICE
	#
	initData = Ice.InitializationData()
	initData.properties = Ice.createProperties([], initData.properties)
	initData.properties.setProperty('Ice.Default.EncodingVersion', '1.0')

	communicator = Ice.initialize(initData)
	proxy = communicator.stringToProxy(proxyString)
	remoteControl = Ellisys.Platform.NetworkRemoteControl.Analyzer.AnalyzerRemoteControlPrx.checkedCast(proxy)

	if not remoteControl:
		sys.exit("Invalid proxy {0}".format(proxyString))

	print("Creating CSV output from currently open trace...")

	Tools().ExportToCsv(remoteControl, "export.csv")

	remoteControl.ReleaseAllOverviewItemHandles()

	sys.exit()
	
except:
	traceback.print_exc()
	
if communicator:
	try:
		communicator.destroy()
	except:
		traceback.print_exc()
