#ifndef _ELLISYS_ETH_ANALYZER_REMOTE_CONTROL_ICE
#define _ELLISYS_ETH_ANALYZER_REMOTE_CONTROL_ICE

#include "AnalyzerRemoteControl.ice"

module Ellisys
{
	module Platform
	{
		module NetworkRemoteControl
		{
			module Analyzer
			{
				module Ethernet
				{
					const string EthernetAnalyzerRemoteControlIdentity = "Ellisys.AnalyzerRemoteControl.Ethernet";
				
					sequence<long> DeviceAddressArray;

					enum DeviceFilterMode
					{
						KeepAll,
						ExcludeBackground,
						KeepOnly,
						KeepInvolving
					};

					interface EthernetAnalyzerRemoteControl extends AnalyzerRemoteControl
					{
						void AddWifiKeyByApSsid(string apSsid, string key) throws OperationFailed;
						void AddWifiKeyByApMacAddr(long apMacAddr, string key) throws OperationFailed;
						void ConfigureDeviceFilter(DeviceFilterMode mode, DeviceAddressArray deviceAddrs) throws OperationFailed;
					};
				}
			};
		};
	};
};

#endif 
