#ifndef _ELLISYS_ETH_ANALYZER_REMOTE_CONTROL_ICE
#define _ELLISYS_ETH_ANALYZER_REMOTE_CONTROL_ICE

#include "AnalyzerRemoteControl.ice"

module Ellisys
{
	module Platform
	{
		module NetworkRemoteControl
		{
			module Analyzer
			{
				module Wpan
				{
					const string WpanAnalyzerRemoteControlIdentity = "Ellisys.AnalyzerRemoteControl.Wpan";
				
					sequence<byte> ByteArray;
				
					interface WpanAnalyzerRemoteControl extends AnalyzerRemoteControl
					{
						void AddThreadNetworkMasterKey(int panId, ByteArray key128, long sequenceCounter);
						void RemoveThreadNetworkAllMasterKeys();
						void RemoveThreadNetworkMasterKeys(int panId);
						void RemoveThreadNetworkMasterKey(int panId, ByteArray key128);

						void AddZigbeeApsKey(ByteArray destinationAddress64, ByteArray sourceAddress64, ByteArray key128);
						void RemoveZigbeeApsAllKeys();
						void RemoveZigbeeApsKeys(ByteArray destinationAddress64, ByteArray sourceAddress64);
						void RemoveZigbeeApsKey(ByteArray destinationAddress64, ByteArray sourceAddress64, ByteArray key128);

						void AddZigbeeNetworkKey(int panId, ByteArray key128);
						void RemoveZigbeeNetworkAllKeys();
						void RemoveZigbeeNetworkKeys(int panId);
						void RemoveZigbeeNetworkKey(int panId, ByteArray key128);
					};
				}
			};
		};
	};
};

#endif 
