import sys, traceback, msvcrt, time, tempfile, os
import Ice

Ice.loadSlice("--all -I. BluetoothAnalyzerRemoteControl.ice")

import Ellisys.Platform.NetworkRemoteControl.Analyzer

# TODO: Please adapt the following constants to your needs
hostIp = "localhost"
hostPort = 12345

proxyString = "{0}:tcp -h {1} -p {2}".format(Ellisys.Platform.NetworkRemoteControl.Analyzer.AnalyzerRemoteControlIdentity, hostIp, hostPort)

try:
	#
	# Initialize ICE
	#
	initData = Ice.InitializationData()
	initData.properties = Ice.createProperties([], initData.properties)
	initData.properties.setProperty("Ice.Default.EncodingVersion", "1.0")

	communicator = Ice.initialize(initData)
	proxy = communicator.stringToProxy(proxyString)
	remoteControl = Ellisys.Platform.NetworkRemoteControl.Analyzer.BluetoothAnalyzerRemoteControlPrx.checkedCast(proxy)

	if not remoteControl:
		sys.exit("Invalid proxy {0}".format(proxyString))

	#
	# Start recording, wait a key and save the trace
	#
	remoteControl.StartRecording()

	print("Recording started.  Please type any key to stop...")

	while remoteControl.IsRecording():
		time.sleep(0.1)
		if msvcrt.kbhit():
			msvcrt.getch()
			break

	if not remoteControl.IsRecording():
		print("Recording stopped automatically.")
	else:
		print("Recording will be stopped.")

		
	tracePath = os.path.join(tempfile.gettempdir(), "trace")
	remoteControl.StopRecordingAndSaveTraceFile(tracePath, True);
	
	print("Trace saved to '{0}'".format(tracePath))
	
except:
	traceback.print_exc()
	
if communicator:
	try:
		communicator.destroy()
	except:
		traceback.print_exc()
